//+------------------------------------------------------------------+
//|                                     Bulls & Bears with ratio.mq4 |
//| according to profitrade idea                                     |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 DimGray
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_level1 0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int  BullsBearsPeriod         = 13;
extern bool UseVolumeForCalculations = true;
extern bool ShowBullsBears           = true;
extern bool ShowRatio                = true;

//
//
//
//
//

double bearsBuffer[];
double bullsBuffer[];
double ratioBuffer[];
double bearsVuffer[];
double bullsVuffer[];
double ratioVuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if (!ShowBullsBears && !ShowRatio)
   {
      ShowBullsBears = true;
      ShowRatio      = true;
   }      
   IndicatorBuffers(6);
   SetIndexBuffer(0,bullsBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bearsBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ratioBuffer);
   SetIndexBuffer(3,bullsVuffer);
   SetIndexBuffer(4,bearsVuffer);
   SetIndexBuffer(5,ratioVuffer);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double bulls  = iBullsPower(NULL, 0, BullsBearsPeriod,PRICE_CLOSE,i);
      double bears  = iBearsPower(NULL, 0, BullsBearsPeriod,PRICE_CLOSE,i);
      double volume = Volume[i]; if (!UseVolumeForCalculations) volume = 1;
      
      //
      //
      //
      //
      //
      
         bullsVuffer[i] = EMPTY_VALUE;
         bearsVuffer[i] = EMPTY_VALUE;
         ratioVuffer[i] = 0;
            if ((bulls+bears)!=0)
            {
                  double vbulls = (bulls*volume)/(bulls+bears);
                  double vbears = (bears*volume)/(bulls+bears);
                     bullsVuffer[i] = vbulls;
                     bearsVuffer[i] = vbears;
                     if (bears<bulls)
                          ratioVuffer[i] = vbears/vbulls;
                     else ratioVuffer[i] = vbulls/vbears;
            }

      //
      //
      //
      //
      //
      
      if (ShowBullsBears) { bullsBuffer[i] = bullsVuffer[i]; bearsBuffer[i] = bearsVuffer[i]; }
      if (ShowRatio)      { ratioBuffer[i] = ratioVuffer[i]; }
   }
   return(0);
}

